#include    "../header/cc2500.h"
/***********************************************
 :	Byte_Write()
 :	д1ֽݵSPIӿ 
 :	byte
 :	/
 :	/
***********************************************/
void    Byte_Write(unsigned char byte)
{
        unsigned char i;
        
        for(i = 0x00; i < 0x08; i++)
        {
            if(byte&0x80)
                iSPI_Sdi= positive;
            else
                iSPI_Sdi= negative;
                
            byte      <<= 0x01;
            iSPI_Sck    = positive;
            iSPI_Sck    = negative;
        }
}
/***********************************************
 :	Byte_Read()
 :	1ֽ 
 :	/
 :	byte
 :	/
***********************************************/
uchar   Byte_Read(void)
{
        unsigned char i;
        unsigned char byte;        
        
        iSPI_Sdo        = positive;
        
        for(i = 0x00; i < 0x08; i++)
        {
            byte      <<= 0x01;
            
            iSPI_Sck    = positive;
            
            if(iSPI_Sdo)
                byte   |= 0x01;
            else
                byte   &= 0xfe;
                
            iSPI_Sck    = negative;
        }
        
        return byte;
}
/***********************************************
 :	cc2500_Register_Write()
 :	дݵcc2500ڲĴ 
 :	addr,para
 :	/
 :	/
***********************************************/
void    cc2500_Register_Write(unsigned char addr,unsigned char para)
{
        iSPI_Sck        = negative;
        iSPI_Scs        = negative;
        
        addr           &= 0x3f;         /* bit7 = 0(write),bit6 = 0(no burst) */
        
        Byte_Write(addr);
        
        Byte_Write(para);
        
        iSPI_Scs        = positive;
}
/***********************************************
 :	cc2500_PowerTable_Write()
 :	д书ʱݵcc2500ڲĴ 
 :	/
 :	/
 :	/
***********************************************/
void    cc2500_PowerTable_Write(void)
{
        uchar i;
        
        iSPI_Sck        = negative;
        iSPI_Scs        = negative;
        
        Byte_Write(Reg_PA_Table|Burst_Write);
        
        for(i = 0x00;i < 0x08;i++)
        {
            Byte_Write(flash_Power_Table[i]);
        } 
        
        iSPI_Scs        = positive;
}
/***********************************************
 :	cc2500_Strobe_Write()
 :	дݵcc2500ڲĴ 
 :	command
 :	/
 :	command  = 0x30 - 0x3d
***********************************************/
void    cc2500_Strobe_Write(unsigned char command)
{
        iSPI_Sck        = negative;
        iSPI_Scs        = negative;
        
        command           &= 0x3f;
        
        Byte_Write(command);
        
        iSPI_Scs        = positive;
}
/***********************************************
 :	RF_Fifo_Write()
 :	дݵcc2500 FIFO 
 :	write_buff
 :	/
 :	command  = 0x30 - 0x3d
***********************************************/
void    RF_Fifo_Write(unsigned char *write_buff)
{
        unsigned char i;
        
        iSPI_Sck        = negative;
        iSPI_Scs        = negative;
        
        /* дcc2500-FIFO */
        Byte_Write(0x7f);

        /* дcc2500-FIFO */
        for(i = 0x00;i < C_FIFO_Byte;i++)
        {
            Byte_Write(*write_buff);
            
            write_buff ++;
        }
        
        iSPI_Scs        = positive;
}
/***********************************************
 :	RF_Fifo_Read()
 :	ݴcc2500 FIFO 
 :	read_buff
 :	/
 :	/
***********************************************/
void    RF_Fifo_Read(unsigned char *read_buff)
{
        unsigned char i;
        
        iSPI_Sck        = negative;
        iSPI_Scs        = negative;
     
        /* cc2500-FIFO */
        Byte_Write(0xff);
        

        /* cc2500-FIFO */
        for(i = 0x00;i < C_FIFO_Byte;i++)
        {
            *read_buff  = Byte_Read();
           
            read_buff ++;

        }        
                  
        iSPI_Scs        = positive;
}
/***********************************************
 :	CC2500_Reset_Chip()
 :	λCC2500оƬ
 :	/
 :	/
 :	/
***********************************************/
void    CC2500_Reset_Chip(void)
{
        /* дCC2500оƬReset */
        cc2500_Strobe_Write(Strobe_SRES);  //sres оƬ
}
/***********************************************
 :	RF_Setup_receiver()
 :	CC2500Ϊ״̬
 :	/
 :	/
 :	/
***********************************************/
void    RF_Setup_receiver(void)
{
        iRF_PaEnable     = disable; 
		cc2500_Strobe_Write(Strobe_SFRX);
        cc2500_Strobe_Write(Strobe_SRX);
}
/***********************************************
 :	RF_Setup_transmiter()
 :	CC2500Ϊ״̬
 :	/
 :	/
 :	/
***********************************************/
void    RF_Setup_transmiter(void)
{
        iRF_PaEnable     = enable;        
        cc2500_Strobe_Write(Strobe_STX);
}
/***********************************************
RF_Clear_Rxfifo(void)
ܣϴFIFO
************************************************/
/*void RF_Clear_Rxfifo(void)
{  iRF_PaEnable     = disable;
    cc2500_Strobe_Write(Strobe_SFRX);
  }

/************************************************
RF_Clear_Txfifo(void)
ܣϴFIFO
************************************************/
/*void RF_Clear_Txfifo(void)
{       
      iRF_PaEnable     = enable;        
        cc2500_Strobe_Write(Strobe_SFTX);
  }


/***********************************************
 :	Initialisation_RF()
 :	ϵʼcc2500
 :	/
 :	/
 :	Fdef = 41.25khz , BW = 135khz  
        Rate = 10kbps , Fif  = 228.5khz
***********************************************/
void    Initialisation_RF(void)
{
        unsigned char i;
        
        iRF_PaEnable     = disable;
        
        CC2500_Reset_Chip();
        
        for(i = 0x00;i < 0xff;i++)
        {
            _nop_();
            _nop_();
            _nop_();
        }
        
        cc2500_Register_Write(Reg_Fsctrl1,0x0c); 
           
        /* frequency offset = 0 */
        cc2500_Register_Write(Reg_Fsctrl0,0x00);
            
        /* Fosc = 26Mhz,Freq = 0x5bc4ec,base freq = Fosc/65536 * Freq = 2386Mhz */        
        cc2500_Register_Write(Reg_Freq2,0x5c);              
        cc2500_Register_Write(Reg_Freq1,0x58);              
        cc2500_Register_Write(Reg_Freq0,0x9d);  
        
        /* Fosc = 26Mhz,BW_E = 10,BW_M = 00,channel BW = Fosc/8/(4+BW_M) = 203Khz */    
        cc2500_Register_Write(Reg_Mdmcfg4,0x86);
        
        /* DATA_E = 0b0000 1000, DATA_M = 0b1001 0011,data rate = (256+DATA_M)*(2^DATA_E)*Fosc/(2^28) = 10kbps */
        cc2500_Register_Write(Reg_Mdmcfg3,0x83);
        cc2500_Register_Write(Reg_Mdmcfg2,0x83);
        
        /* enable FEC,preamble bytes = 24bits */
        cc2500_Register_Write(Reg_Mdmcfg1,0xf2);        
        /* default Fchannel step = 200khz */
        cc2500_Register_Write(Reg_Mdmcfg0,0xf8);  
        
        /* frequency = base freq + Fchannel*Channr = 2386mhz + 200khz*71 = 2400.2mhz */      
        cc2500_Register_Write(Reg_Channr,0x00);
        cc2500_Register_Write(Reg_Deviatn,0x44); 
        
        /* default RX front-end current config */
        cc2500_Register_Write(Reg_Frend1,0xb6);
        
        /* power table */
        cc2500_PowerTable_Write();        
        /* PA_POWER[2:0] = 000 */
        cc2500_Register_Write(Reg_Frend0,0x10);     
        
        /* auto calibration from IDLE to RX O TX,Xosc is off in sleep mode,Xosc stable time 150us  */
        cc2500_Register_Write(Reg_Mcsm0,0x18); 
        
        /* RSSI always  */
        cc2500_Register_Write(Reg_Mcsm1,0x00); 
        
        /* default recommond value */
        cc2500_Register_Write(Reg_Foccfg,0x1d);     
        
        /* default recommond value */
        cc2500_Register_Write(Reg_Bscfg,0x1c);      
        
        /* default recommond value */
        cc2500_Register_Write(Reg_Agcctrl2,0xc7);
        cc2500_Register_Write(Reg_Agcctrl1,0x00);
        cc2500_Register_Write(Reg_Agcctrl0,0xb2);   
        
        /* default recommond value */
        cc2500_Register_Write(Reg_Fscal3,0xea);
        cc2500_Register_Write(Reg_Fscal2,0x0a);
        cc2500_Register_Write(Reg_Fscal1,0x00);       
        cc2500_Register_Write(Reg_Fscal0,0x11);   
        
        /* Asserts when sync word has been sent / received, and de-asserts at the end of the packet */
        cc2500_Register_Write(Reg_Iocfg2,0x06);     
        /* Fosc/8 output */
        cc2500_Register_Write(Reg_Iocfg1,0x36); 
        /* clear channel indicate */
        cc2500_Register_Write(Reg_Iocfg0,0x09);    
        
        /* enable auto flush FIFO when CRC is error,no address check */
        cc2500_Register_Write(Reg_Pktctrl1,0x08);         
         
        /* whitening off,packet format is normal mode,enable CRC */
        cc2500_Register_Write(Reg_Pktctrl0,0x04);
        
        /* FIFO packet length is C_FIFO_Byte */
        cc2500_Register_Write(Reg_Pktlen,C_FIFO_Byte);     
        
        /* sync byte */
        cc2500_Register_Write(Reg_Sync1,C_SYNC_Byte1);
        cc2500_Register_Write(Reg_Sync0,C_SYNC_Byte0);


        RF_Setup_receiver();
}        